// ======================================================================== //
// Copyright 2009-2016 Intel Corporation                                    //
//                                                                          //
// Licensed under the Apache License, Version 2.0 (the "License");          //
// you may not use this file except in compliance with the License.         //
// You may obtain a copy of the License at                                  //
//                                                                          //
//     http://www.apache.org/licenses/LICENSE-2.0                           //
//                                                                          //
// Unless required by applicable law or agreed to in writing, software      //
// distributed under the License is distributed on an "AS IS" BASIS,        //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. //
// See the License for the specific language governing permissions and      //
// limitations under the License.                                           //
//																			//
// Modified by Jacob Munkberg												//
// ======================================================================== //

#pragma once

#include <embree2/rtcore.h>
#include "../common/math/vec3.h"
#include "../support/scenegraph/ray.h"
#include "../support/scenegraph/differentialgeometry.h"

namespace embree {
	// Forward declarations
	struct Scene;

	/* Helper class with static functions */
	class SceneConversion {
	public:
		static void Error_handler(const RTCError code, const char* str = nullptr);
		static RTCScene ConvertScene(Scene* scene_in, RTCDevice device);
		static int PostIntersect(const RTCRay& ray, Scene* tut_scene, DifferentialGeometry& dg);
		static int GetMaterialID(Scene* tut_scene, const int geomID, const int primID);
	};
}